## dogtag-pki 10.6.0

=== CMakeLists.txt ===
project(pki)

# Required cmake version
cmake_minimum_required(VERSION 2.6.0)

# global needed variables
set(APPLICATION_NAME ${PROJECT_NAME})

# Un-comment the following line to add 'javac' options (e. g. - "-g" debugging)
#set(CMAKE_JAVA_COMPILE_FLAGS "-g")

if (NOT DEFINED VERSION)
    set(VERSION "10.0.0")
endif(NOT DEFINED VERSION)

if (NOT DEFINED PKI_NSS_DB_TYPE)
    set(PKI_NSS_DB_TYPE "dbm")
endif(NOT DEFINED PKI_NSS_DB_TYPE)

string(REGEX REPLACE "^([0-9]+).*" "\\1" APPLICATION_VERSION_MAJOR ${VERSION})
string(REGEX REPLACE "^[0-9]+\\.([0-9]+).*" "\\1" APPLICATION_VERSION_MINOR ${VERSION})
string(REGEX REPLACE "^[0-9]+\\.[0-9]+\\.([0-9]+).*" "\\1" APPLICATION_VERSION_PATCH ${VERSION})

set(APP_SERVER "tomcat-8.0" CACHE STRING "Application server")

option(WITH_SERVER "Build server package" ON)
option(WITH_JAVADOC "Build Javadoc package" ON)
option(WITH_TEST "Run unit tests" ON)
option(WITH_PYTHON2 "Build with Python 2 support" ON)
option(WITH_PYTHON3 "Build with Python 3 support" ON)
option(WITH_PYTHON3_DEFAULT "Build server and scripts with Python 3" OFF)

set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}")

# where to look first for cmake modules
# (before ${CMAKE_ROOT}/Modules/ is checked)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules)

# add definitions
include(DefineCMakeDefaults)
include(DefinePlatformDefaults)
include(DefineCompilerFlags)
include(DefineInstallationPaths)
include(DefineOptions)
include(CPackConfig)

# disallow in-source build
include(MacroEnsureOutOfSourceBuild)
macro_ensure_out_of_source_build("${PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there.")

# add macros
include(MacroCopyFile)
include(Java)

file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/dist)

# required for all PKI components
include(JUnit)

# search for libraries

# required for all PKI components EXCEPT Theme-based components
if (BUILD_PKI_CORE OR BUILD_PKI_CONSOLE)
    find_package(NSPR REQUIRED)
    find_package(NSS REQUIRED)
endif ()

find_package(Java REQUIRED)
find_package(JNI REQUIRED)

# ONLY required for PKI_CORE
if (BUILD_PKI_CORE)
    find_package(Ldap REQUIRED)
    # required for native 'tpsclient' utility
    find_package(APR REQUIRED)
endif ()

# Find out if we have threading available
set(CMAKE_THREAD_PREFER_PTHREADS ON)
find_package(Threads)

# NSS default database type
if (PKI_NSS_DB_TYPE STREQUAL "dbm")
    message(STATUS "Using old 'dbm' format for NSS_DEFAULT_DB_TYPE")
elseif (PKI_NSS_DB_TYPE STREQUAL "sql")
    message(STATUS "Using new 'sql' format for NSS_DEFAULT_DB_TYPE")
else()
    message(FATAL_ERROR "Unsupported PKI_NSS_DB_TYPE=${PKI_NSS_DB_TYPE}")
endif()

# Detect default Python interpreter
# Set PYTHON2_SITE_PACKAGES, PYTHON3_SITE_PACKAGES
if (BUILD_PKI_CORE OR BUILD_PKI_CONSOLE)
    include(DefinePythonSitePackages)
endif ()

# config.h checks
include(ConfigureChecks)
configure_file(cmake/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)

add_definitions(-DHAVE_CONFIG_H)

# uninstall target
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
               IMMEDIATE @ONLY)

add_custom_target(uninstall
                  COMMAND ${CMAKE_COMMAND}
                      -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

# clean-dist target
add_custom_target(clean-dist
    COMMAND ${CMAKE_COMMAND}
        -E remove_directory ${CMAKE_BINARY_DIR}/dist
)

# clean-cmake target
add_custom_target(clean-cmake
    COMMAND ${CMAKE_COMMAND}
        -E remove_directory ${CMAKE_BINARY_DIR}/base
    COMMAND ${CMAKE_COMMAND}
        -E remove_directory ${CMAKE_BINARY_DIR}/CMakeFiles
    COMMAND ${CMAKE_COMMAND}
        -E remove -f
        ${CMAKE_BINARY_DIR}/CMakeCache.txt
        ${CMAKE_BINARY_DIR}/cmake_install.cmake
        ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake
        ${CMAKE_BINARY_DIR}/config.h
        ${CMAKE_BINARY_DIR}/CPackConfig.cmake
        ${CMAKE_BINARY_DIR}/CPackSourceConfig.cmake
        ${CMAKE_BINARY_DIR}/install_manifest.txt
        ${CMAKE_BINARY_DIR}/Makefile
)

# check subdirectories
if (BUILD_PKI_CORE OR BUILD_PKI_CONSOLE)
    add_subdirectory(base)
endif ()

# 'Themes' MUST be "mutually-exclusive"!
if (BUILD_DOGTAG_PKI_THEME)
    add_subdirectory(dogtag)
elseif (BUILD_REDHAT_PKI_THEME)
    add_subdirectory(redhat)
endif ()

=== base/CMakeLists.txt ===
project(base)

find_file(SERVLET_JAR
    NAMES
        servlet.jar
        servlet-api-3.1.jar
    PATHS
        /usr/share/java
)

find_file(JAXRS_API_JAR
    NAMES
        jaxrs-api.jar
        jboss-jaxrs-2.0-api.jar
        javax.ws.rs-api.jar
    PATHS
        ${RESTEASY_LIB}
        /usr/share/java
)

find_file(SLF4J_API_JAR
    NAMES
        slf4j-api.jar
    PATHS
        /usr/share/java/slf4j
        /usr/share/java
)

find_file(SLF4J_JDK14_JAR
    NAMES
        slf4j-jdk14.jar
    PATHS
        /usr/share/java/slf4j
        /usr/share/java
)

find_file(COMMONS_CLI_JAR
    NAMES
        commons-cli.jar
    PATHS
        /usr/share/java
)

find_file(COMMONS_CODEC_JAR
    NAMES
        commons-codec.jar
    PATHS
        /usr/share/java
)

find_file(COMMONS_COLLECTIONS_JAR
    NAMES
        commons-collections.jar
        commons-collections3.jar
    PATHS
        /usr/share/java
)

find_file(COMMONS_HTTPCLIENT_JAR
    NAMES
        commons-httpclient.jar
    PATHS
        /usr/share/java
)

find_file(COMMONS_IO_JAR
    NAMES
        commons-io.jar
    PATHS
        /usr/share/java
)

find_file(COMMONS_LANG_JAR
    NAMES
        commons-lang.jar
    PATHS
        /usr/share/java
)

find_file(COMMONS_LOGGING_JAR
    NAMES
        commons-logging.jar
    PATHS
        /usr/share/java
)

find_file(HAMCREST_JAR
    NAMES
        core.jar
    PATHS
        /usr/share/java/hamcrest
)

find_file(HTTPCLIENT_JAR
    NAMES
        httpclient.jar
    PATHS
        /usr/share/java/httpcomponents
        /usr/share/java
)

find_file(HTTPCORE_JAR
    NAMES
        httpcore.jar
    PATHS
        /usr/share/java/httpcomponents
        /usr/share/java
)

find_file(JACKSON_CORE_JAR
    NAMES
        jackson-core-asl.jar
    PATHS
        /usr/share/java/jackson
        /usr/share/java
)

find_file(JACKSON_JAXRS_JAR
    NAMES
        jackson-jaxrs.jar
    PATHS
        /usr/share/java/jackson
        /usr/share/java
)

find_file(JACKSON_MAPPER_JAR
    NAMES
        jackson-mapper-asl.jar
    PATHS
        /usr/share/java/jackson
        /usr/share/java
)

find_file(JACKSON_MRBEAN_JAR
    NAMES
        jackson-mrbean.jar
    PATHS
        /usr/share/java/jackson
        /usr/share/java
)

find_file(JACKSON_SMILE_JAR
    NAMES
        jackson-smile.jar
    PATHS
        /usr/share/java/jackson
        /usr/share/java
)

find_file(JACKSON_XC_JAR
    NAMES
        jackson-xc.jar
    PATHS
        /usr/share/java/jackson
        /usr/share/java
)

find_file(JAXB_API_JAR
    NAMES
        jaxb-api.jar
    PATHS
        /usr/share/java
)

find_file(JSS_JAR
    NAMES
        jss4.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(JUNIT_JAR
    NAMES
        junit.jar
        junit4.jar
    PATHS
        /usr/share/java
)

find_file(LDAPJDK_JAR
    NAMES
        ldapjdk.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(NUXWDOG_JAR
    NAMES
        nuxwdog.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(RESTEASY_JAXRS_JAR
    NAMES
        resteasy-jaxrs.jar
    PATHS
        ${RESTEASY_LIB}
)

find_file(RESTEASY_ATOM_PROVIDER_JAR
    NAMES
        resteasy-atom-provider.jar
    PATHS
        ${RESTEASY_LIB}
)

find_file(JASPIC_API_JAR
    NAMES
        jaspic-api.jar
        tomcat8-jaspic-api.jar
    PATHS
        /usr/share/java/tomcat
        /usr/share/java
)

find_file(TOMCAT_API_JAR
    NAMES
        tomcat-api.jar
        tomcat8-api.jar
    PATHS
        /usr/share/java/tomcat
        /usr/share/java
)

find_file(TOMCAT_CATALINA_JAR
    NAMES
        catalina.jar
        tomcat8-catalina.jar
    PATHS
        /usr/share/java/tomcat
        /usr/share/java
)

find_file(TOMCAT_COYOTE_JAR
    NAMES
        tomcat-coyote.jar
        tomcat8-coyote.jar
    PATHS
        /usr/share/java/tomcat
        /usr/share/java
)

find_file(TOMCAT_UTIL_JAR
    NAMES
        tomcat-util.jar
        tomcat8-util.jar
    PATHS
        /usr/share/java/tomcat
        /usr/share/java
)

find_file(TOMCAT_UTIL_SCAN_JAR
    NAMES
        tomcat-util-scan.jar
        tomcat8-util-scan.jar
    PATHS
        /usr/share/java/tomcat
        /usr/share/java
)

find_file(TOMCATJSS_JAR
    NAMES
        tomcatjss.jar
    PATHS
        /usr/share/java
)

find_file(VELOCITY_JAR
    NAMES
        velocity.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(XALAN_JAR
    NAMES
        xalan-j2.jar
        xalan2.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(XERCES_JAR
    NAMES
        xerces-j2.jar
        xercesImpl.jar
    PATHS
        ${JAVA_LIB_INSTALL_DIR}
        /usr/share/java
)

find_file(XML_COMMONS_APIS_JAR
    NAMES
        xml-commons-apis.jar
        xml-apis.jar
    PATHS
        /usr/share/java
)

find_file(XML_COMMONS_RESOLVER_JAR
    NAMES
        xml-commons-resolver.jar
        xml-resolver.jar
    PATHS
        /usr/share/java
)

# The order is important!
if (BUILD_PKI_CORE OR BUILD_PKI_CONSOLE)
    add_subdirectory(test)
    add_subdirectory(symkey)
    add_subdirectory(util)
    add_subdirectory(common)
    add_subdirectory(native-tools)
    add_subdirectory(java-tools)

    if(WITH_SERVER)
        add_subdirectory(server)
        add_subdirectory(ca)
        add_subdirectory(kra)
        add_subdirectory(ocsp)
        add_subdirectory(tks)
        add_subdirectory(tps)
        # required for native 'tpsclient' utility
        add_subdirectory(tps-client)

        if(WITH_JAVADOC)
            add_subdirectory(javadoc)
        endif(WITH_JAVADOC)

    endif(WITH_SERVER)

    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/VERSION
        ${CMAKE_CURRENT_BINARY_DIR}/VERSION
    )

    install(
        FILES
            ${CMAKE_CURRENT_BINARY_DIR}/VERSION
        DESTINATION
            ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}
    )

endif (BUILD_PKI_CORE OR BUILD_PKI_CONSOLE)

if (BUILD_PKI_CONSOLE)
    add_subdirectory(console)
endif (BUILD_PKI_CONSOLE)

=== dogtag/CMakeLists.txt ===
project(dogtag)

if (BUILD_DOGTAG_PKI_THEME)
    add_subdirectory(common-ui)
    add_subdirectory(console-ui)
endif (BUILD_DOGTAG_PKI_THEME)

=== base/ca/CMakeLists.txt ===
project(ca NONE)

add_subdirectory(src)
add_subdirectory(setup)
add_subdirectory(shared/conf)
add_subdirectory(${APP_SERVER})

# Create links at /usr/share/pki/ca/webapps/ca/admin/console.
# Create links in /usr/share/pki/ca/webapps/ca/WEB-INF/lib.
# This can be customized for different platforms in RPM spec.

add_custom_target(pki-ca-links ALL)

add_custom_command(
    TARGET pki-ca-links
    COMMAND ${CMAKE_COMMAND} -E make_directory webapp/admin
    COMMAND ln -sf ${DATA_INSTALL_DIR}/server/webapps/pki/admin/console ${CMAKE_CURRENT_BINARY_DIR}/webapp/admin
    COMMAND ${CMAKE_COMMAND} -E make_directory webapp/lib
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_API_JAR} webapp/lib/slf4j-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_JDK14_JAR} webapp/lib/slf4j-jdk14.jar
    COMMAND ln -sf /usr/share/java/pki/pki-certsrv.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-certsrv.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cms.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cms.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmscore.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cmscore.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmsbundle.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cmsbundle.jar
    COMMAND ln -sf /usr/share/java/pki/pki-ca.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-ca.jar
)

# install directories
install(
    DIRECTORY
        shared/
    DESTINATION
        ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}
    PATTERN
        "CMakeLists.txt" EXCLUDE
)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/webapp/admin/
    DESTINATION
        ${DATA_INSTALL_DIR}/ca/webapps/ca/admin
)

install(
    DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/
    DESTINATION
        ${DATA_INSTALL_DIR}/ca/webapps/ca/WEB-INF/lib
)

# install empty directories
install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/lock/pki/ca
)

install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/run/pki/ca
)

=== base/common/CMakeLists.txt ===
project(common NONE)

# install common configuration files
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/share/etc/pki.conf
    ${CMAKE_CURRENT_BINARY_DIR}/share/etc/pki.conf
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/etc/pki.conf
    ${CMAKE_CURRENT_BINARY_DIR}/etc/pki.conf
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/sbin/pki-upgrade.in
    ${CMAKE_CURRENT_BINARY_DIR}/sbin/pki-upgrade
)

# Create /usr/share/pki/lib. This can be customized for different platforms in RPM spec.

add_custom_target(pki-lib ALL)

add_custom_command(
    TARGET pki-lib
    COMMAND ${CMAKE_COMMAND} -E make_directory lib
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_CLI_JAR} lib/commons-cli.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_CODEC_JAR} lib/commons-codec.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_HTTPCLIENT_JAR} lib/commons-httpclient.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_IO_JAR} lib/commons-io.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_LANG_JAR} lib/commons-lang.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_LOGGING_JAR} lib/commons-logging.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${HTTPCLIENT_JAR} lib/httpclient.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${HTTPCORE_JAR} lib/httpcore.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON_CORE_JAR} lib/jackson-core-asl.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON_JAXRS_JAR} lib/jackson-jaxrs.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON_MAPPER_JAR} lib/jackson-mapper-asl.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON_MRBEAN_JAR} lib/jackson-mrbean.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON_SMILE_JAR} lib/jackson-smile.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON_XC_JAR} lib/jackson-xc.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JAXB_API_JAR} lib/jaxb-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JSS_JAR} lib/jss4.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${LDAPJDK_JAR} lib/ldapjdk.jar
    COMMAND ln -sf /usr/share/java/pki/pki-certsrv.jar ${CMAKE_CURRENT_BINARY_DIR}/lib/pki-certsrv.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmsutil.jar ${CMAKE_CURRENT_BINARY_DIR}/lib/pki-cmsutil.jar
    COMMAND ln -sf /usr/share/java/pki/pki-nsutil.jar ${CMAKE_CURRENT_BINARY_DIR}/lib/pki-nsutil.jar
    COMMAND ln -sf /usr/share/java/pki/pki-tools.jar ${CMAKE_CURRENT_BINARY_DIR}/lib/pki-tools.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${RESTEASY_ATOM_PROVIDER_JAR} lib/resteasy-atom-provider.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${RESTEASY_LIB}/resteasy-client.jar lib/resteasy-client.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${RESTEASY_LIB}/resteasy-jackson-provider.jar lib/resteasy-jackson-provider.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${RESTEASY_LIB}/resteasy-jaxb-provider.jar lib/resteasy-jaxb-provider.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JAXRS_API_JAR} lib/jaxrs-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${RESTEASY_LIB}/resteasy-jaxrs.jar lib/resteasy-jaxrs.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SERVLET_JAR} lib/servlet.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_API_JAR} lib/slf4j-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_JDK14_JAR} lib/slf4j-jdk14.jar
)

install(
    DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/lib/
    DESTINATION
        ${DATA_INSTALL_DIR}/lib
)

install(
    FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/share/etc/logging.properties
        ${CMAKE_CURRENT_BINARY_DIR}/share/etc/pki.conf
    DESTINATION
        ${DATA_INSTALL_DIR}/etc/
)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/etc/pki.conf
    DESTINATION
        ${SYSCONF_INSTALL_DIR}/pki/
)

# install executables
install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/sbin/pki-upgrade
    DESTINATION
        ${SBIN_INSTALL_DIR}
    PERMISSIONS
        OWNER_EXECUTE OWNER_WRITE OWNER_READ
        GROUP_EXECUTE GROUP_READ
        WORLD_EXECUTE WORLD_READ
)

install(
    FILES
        scripts/config
    DESTINATION
        ${DATA_INSTALL_DIR}/scripts/
    PERMISSIONS
        OWNER_WRITE OWNER_READ
        GROUP_READ
        WORLD_READ
)

install(
    DIRECTORY
        upgrade
    DESTINATION
        ${DATA_INSTALL_DIR}/
    FILE_PERMISSIONS
        OWNER_EXECUTE OWNER_WRITE OWNER_READ
        GROUP_EXECUTE GROUP_READ
        WORLD_EXECUTE WORLD_READ
    PATTERN ".gitignore" EXCLUDE
)

install(
    DIRECTORY
        key
    DESTINATION
        ${DATA_INSTALL_DIR}/
    FILE_PERMISSIONS
        OWNER_READ
        GROUP_READ
        WORLD_READ
)

# install empty directories
install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/lock/pki/tomcat
)

install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/run/pki/tomcat
)

install(
    DIRECTORY
    DESTINATION 
        ${SYSTEMD_ETC_INSTALL_DIR}/pki-tomcatd.target.wants
)

install(
    DIRECTORY
    DESTINATION
        ${SYSTEMD_ETC_INSTALL_DIR}/pki-tomcatd-nuxwdog.target.wants
)

install(
    DIRECTORY
    DESTINATION
        /etc/sysconfig/pki
)

install(
    DIRECTORY
    DESTINATION
        /etc/sysconfig/pki/tomcat
)

install(
    DIRECTORY
        man/
    DESTINATION
        ${MAN_INSTALL_DIR}
    FILE_PERMISSIONS
        OWNER_READ OWNER_WRITE
        GROUP_READ
        WORLD_READ
)

add_subdirectory(src)
add_subdirectory(examples)
add_subdirectory(python)

=== base/java-tools/CMakeLists.txt ===
project(java-tools NONE)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/pki.in
    ${CMAKE_CURRENT_BINARY_DIR}/bin/pki
)

install(
    DIRECTORY
        man/
    DESTINATION
        ${MAN_INSTALL_DIR}
    FILE_PERMISSIONS
        OWNER_READ OWNER_WRITE
        GROUP_READ
        WORLD_READ
)

# Create compatibility symlink for DRMTool.1.gz -> KRATool.1.gz

add_custom_target(pki-DRMTool-man-link ALL)

add_custom_command(
    TARGET pki-DRMTool-man-link
    COMMAND ln -sf ${MAN_INSTALL_DIR}/man1/KRATool.1.gz ${CMAKE_CURRENT_BINARY_DIR}/DRMTool.1.gz
)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/DRMTool.1.gz
    DESTINATION
        ${MAN_INSTALL_DIR}/man1
    PERMISSIONS
        OWNER_READ OWNER_WRITE
        GROUP_READ
        WORLD_READ
)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/bin/pki
    DESTINATION
        ${BIN_INSTALL_DIR}
    PERMISSIONS
        OWNER_EXECUTE OWNER_WRITE OWNER_READ
        GROUP_EXECUTE GROUP_READ
        WORLD_EXECUTE WORLD_READ
)

add_subdirectory(src)
add_subdirectory(templates)

=== base/javadoc/CMakeLists.txt ===
project(pki-javadoc)

# It is important to identify the version of 'javadoc' being utilized since
# different versions support different options.
#
# While 'cmake' contains numerous built-in references to the 'java' version,
# it contains no built-in references to either the 'javac' or 'javadoc'
# versions, and unfortunately, the specified version of 'java' may be
# different from the specified versions of 'javac' and 'javadoc'.
#
# Additionally, although 'javadoc' contains no command-line option to identify
# its version, it is important to note that 'javadoc' is supplied by the same
# package that supplies 'javac', and although multiple versions of these
# executables could co-exist on the same system, it is relatively safe to
# assert that the currently specified 'javac' and 'javadoc' will be the same
# version.
#
# As an example in support of this assertion, on systems which utilize
# '/usr/sbin/alternatives', setting the 'javac' version will also
# automatically set the 'javadoc' version to match the 'javac' version, and
# 'usr/sbin/alternatives' cannot be used to set a specific 'javadoc' version.
#
# Therefore, regardless of the 'java' version, this 'CMakeLists.txt' file will
# programmatically utilize the invoked 'javac' version information (output is
# to stderr) in order to correctly identify the supported 'javadoc' options:
#
#     # javac -version 2>&1 | awk -F \. '{printf $2}'
#
# NOTE:  Used 'cut' instead of 'awk' due to 'cmake' parsing limitations:
#
#     # javac -version 2>&1 | cut -f2 -d.
#
message( STATUS "Java_VERSION_STRING = '${Java_VERSION_STRING}'" )
execute_process(
    COMMAND
        javac -version
    ERROR_VARIABLE
        Javac_VERSION_OUTPUT
    OUTPUT_VARIABLE
        Javac_VERSION_OUTPUT
    ERROR_STRIP_TRAILING_WHITESPACE
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
message( STATUS "Javac_VERSION_OUTPUT = '${Javac_VERSION_OUTPUT}'" )
execute_process(
    COMMAND
        echo ${Javac_VERSION_OUTPUT}
    COMMAND
        cut -f2 -d.
    OUTPUT_VARIABLE
        Javadoc_VERSION_MINOR
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
message( STATUS "Javadoc_VERSION_MINOR = '${Javadoc_VERSION_MINOR}'" )

# REMINDER:  Eventually, it would almost certainly be safer to obtain the
#            'Javadoc_VERSION_MAJOR' number as well and perform the check
#            on "'Javadoc_VERSION_MAJOR'.'Javadoc_VERSION_MINOR'".
#
set(doclintstr "")
if(NOT (${Javadoc_VERSION_MINOR} LESS 8))
    set(doclintstr "-Xdoclint:none")
endif(NOT (${Javadoc_VERSION_MINOR} LESS 8))

javadoc(pki-javadoc
    SOURCEPATH
        ${CMAKE_SOURCE_DIR}/base/util/src
        ${CMAKE_SOURCE_DIR}/base/common/src
        ${CMAKE_SOURCE_DIR}/base/java-tools/src
        ${CMAKE_SOURCE_DIR}/base/server/cms/src
    DEST
        ${CMAKE_CURRENT_BINARY_DIR}/javadoc/pki-${APPLICATION_VERSION}
    SUBPACKAGES
        com.netscape.certsrv
        com.netscape.cms
        com.netscape.cmstools
        com.netscape.cmsutil
        org.dogtagpki
    CLASSPATH
        ${SLF4J_API_JAR}
        ${XALAN_JAR} ${XERCES_JAR}
        ${COMMONS_CLI_JAR} ${COMMONS_LANG_JAR}
        ${COMMONS_CODEC_JAR} ${COMMONS_HTTPCLIENT_JAR} ${COMMONS_IO_JAR}
        ${LDAPJDK_JAR} ${VELOCITY_JAR}
        ${SERVLET_JAR} ${TOMCAT_CATALINA_JAR} ${TOMCAT_UTIL_JAR}
        ${HTTPCLIENT_JAR} ${HTTPCORE_JAR}
        ${JAXRS_API_JAR} ${RESTEASY_JAXRS_JAR} ${RESTEASY_ATOM_PROVIDER_JAR} ${RESTEASY_CLIENT_JAR}
        ${JSS_JAR} ${SYMKEY_JAR} ${TOMCATJSS_JAR}
        ${PKI_CMSUTIL_JAR} ${PKI_CERTSRV_JAR} ${PKI_TOMCAT_JAR} ${PKI_CMS_JAR} ${PKI_CMSCORE_JAR} ${PKI_TOOLS_JAR}
        ${NUXWDOG_JAR}
    OPTIONS
        -windowtitle 'pki-javadoc'
        -doctitle '<h1>PKI Javadoc</h1>'
        -author
        -use
        -version
        ${doclintstr}
    DEPENDS
        pki-cmsutil-jar pki-certsrv-jar pki-tools-jar pki-tomcat-jar
        pki-cms-jar pki-cmscore-jar pki-ca-jar pki-kra-jar pki-ocsp-jar pki-tks-jar pki-tps-jar
)

install(
    DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/javadoc/pki-${APPLICATION_VERSION}
    DESTINATION
        ${CMAKE_INSTALL_PREFIX}/share/javadoc
)

=== base/kra/CMakeLists.txt ===
project(kra NONE)

add_subdirectory(src)
add_subdirectory(setup)
add_subdirectory(shared/conf)
add_subdirectory(${APP_SERVER})

# Create links at /usr/share/pki/kra/webapps/kra/admin/console.
# Create links in /usr/share/pki/kra/webapps/kra/WEB-INF/lib.
# This can be customized for different platforms in RPM spec.

add_custom_target(pki-kra-links ALL)

add_custom_command(
    TARGET pki-kra-links
    COMMAND ${CMAKE_COMMAND} -E make_directory webapp/admin
    COMMAND ln -sf ${DATA_INSTALL_DIR}/server/webapps/pki/admin/console ${CMAKE_CURRENT_BINARY_DIR}/webapp/admin
    COMMAND ${CMAKE_COMMAND} -E make_directory webapp/lib
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_API_JAR} webapp/lib/slf4j-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_JDK14_JAR} webapp/lib/slf4j-jdk14.jar
    COMMAND ln -sf /usr/share/java/pki/pki-certsrv.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-certsrv.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cms.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cms.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmscore.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cmscore.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmsbundle.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cmsbundle.jar
    COMMAND ln -sf /usr/share/java/pki/pki-kra.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-kra.jar
)

# install directories
install(
    DIRECTORY
        shared/
    DESTINATION
        ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}
    PATTERN
        "CMakeLists.txt" EXCLUDE
)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/webapp/admin/
    DESTINATION
        ${DATA_INSTALL_DIR}/kra/webapps/kra/admin
)

install(
    DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/
    DESTINATION
        ${DATA_INSTALL_DIR}/kra/webapps/kra/WEB-INF/lib
)

# install empty directories
install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/lock/pki/kra
)

install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/run/pki/kra
)

=== base/ocsp/CMakeLists.txt ===
project(ocsp NONE)

add_subdirectory(src)
add_subdirectory(setup)
add_subdirectory(shared/conf)
add_subdirectory(${APP_SERVER})

# Create links at /usr/share/pki/ocsp/webapps/ocsp/admin/console.
# Create links in /usr/share/pki/ocsp/webapps/ocsp/WEB-INF/lib.
# This can be customized for different platforms in RPM spec.

add_custom_target(pki-ocsp-links ALL)

add_custom_command(
    TARGET pki-ocsp-links
    COMMAND ${CMAKE_COMMAND} -E make_directory webapp/admin
    COMMAND ln -sf ${DATA_INSTALL_DIR}/server/webapps/pki/admin/console ${CMAKE_CURRENT_BINARY_DIR}/webapp/admin
    COMMAND ${CMAKE_COMMAND} -E make_directory webapp/lib
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_API_JAR} webapp/lib/slf4j-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_JDK14_JAR} webapp/lib/slf4j-jdk14.jar
    COMMAND ln -sf /usr/share/java/pki/pki-certsrv.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-certsrv.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cms.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cms.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmscore.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cmscore.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmsbundle.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cmsbundle.jar
    COMMAND ln -sf /usr/share/java/pki/pki-ocsp.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-ocsp.jar
)

# install directories
install(
    DIRECTORY
        shared/
    DESTINATION
        ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}
    PATTERN
        "CMakeLists.txt" EXCLUDE
)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/webapp/admin/
    DESTINATION
        ${DATA_INSTALL_DIR}/ocsp/webapps/ocsp/admin
)

install(
    DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/
    DESTINATION
        ${DATA_INSTALL_DIR}/ocsp/webapps/ocsp/WEB-INF/lib
)

# install empty directories
install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/lock/pki/ocsp
)

install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/run/pki/ocsp
)

=== base/server/CMakeLists.txt ===
project(server)

set(PKI_SUBSYSTEMS
    ca
    kra
    ocsp
    ra
    tks
    tps
)

set(TOMCAT_SUBSYSTEMS
    ca
    kra
    ocsp
    tks
)

set(APACHE_SUBSYSTEMS
    ra
    tps
)

add_subdirectory(${APP_SERVER})
add_subdirectory(tomcat)
add_subdirectory(cms)
add_subdirectory(cmsbundle)
add_subdirectory(cmscore)
add_subdirectory(test)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/share/etc/tomcat.conf.in
    ${CMAKE_CURRENT_BINARY_DIR}/share/etc/tomcat.conf
)
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/sbin/pki-server.in
    ${CMAKE_CURRENT_BINARY_DIR}/sbin/pki-server
)
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/sbin/pki-server-upgrade.in
    ${CMAKE_CURRENT_BINARY_DIR}/sbin/pki-server-upgrade
)
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/sbin/pkidestroy.in
    ${CMAKE_CURRENT_BINARY_DIR}/sbin/pkidestroy
)
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/sbin/pkispawn.in
    ${CMAKE_CURRENT_BINARY_DIR}/sbin/pkispawn
)

# build server classes
javac(pki-server-classes
    SOURCES
        cms/src/*.java
        cmscore/src/*.java
    CLASSPATH
        ${SLF4J_API_JAR}
        ${COMMONS_CODEC_JAR} ${COMMONS_HTTPCLIENT_JAR} ${COMMONS_IO_JAR} ${COMMONS_LANG_JAR}
        ${HTTPCORE_JAR} ${HTTPCLIENT_JAR}
        ${JSS_JAR} ${SYMKEY_JAR}
        ${LDAPJDK_JAR}
        ${XALAN_JAR} ${XERCES_JAR}
        ${SERVLET_JAR} ${TOMCAT_CATALINA_JAR} ${TOMCAT_UTIL_JAR}
        ${TOMCATJSS_JAR} ${VELOCITY_JAR}
        ${JAXRS_API_JAR} ${RESTEASY_JAXRS_JAR} ${RESTEASY_ATOM_PROVIDER_JAR}
        ${NUXWDOG_JAR}
        ${PKI_NSUTIL_JAR} ${PKI_CMSUTIL_JAR} ${PKI_CERTSRV_JAR} ${PKI_TOMCAT_JAR}
    OUTPUT_DIR
        ${CMAKE_CURRENT_BINARY_DIR}/classes
    DEPENDS
        pki-nsutil-jar pki-cmsutil-jar pki-certsrv-jar pki-tools-jar pki-tomcat-jar
)

# build pki-cms.jar
jar(pki-cms-jar
    CREATE
        ${CMAKE_BINARY_DIR}/dist/pki-cms.jar
    OPTIONS
        m
    PARAMS
        ${CMAKE_CURRENT_BINARY_DIR}/cms/src/pki-cms.mf
    INPUT_DIR
        ${CMAKE_CURRENT_BINARY_DIR}/classes
    FILES
        com/netscape/cms/*
        org/dogtagpki/legacy/server/policy/*
        org/dogtagpki/server/*
    DEPENDS
        pki-server-classes
)

# build pki-cmscore.jar
jar(pki-cmscore-jar
    CREATE
        ${CMAKE_BINARY_DIR}/dist/pki-cmscore.jar
    OPTIONS
        m
    PARAMS
        ${CMAKE_CURRENT_BINARY_DIR}/cmscore/src/pki-cmscore.mf
    INPUT_DIR
        ${CMAKE_CURRENT_BINARY_DIR}/classes
    FILES
        com/netscape/cmscore/*
        org/dogtagpki/legacy/core/policy/*
    DEPENDS
        pki-server-classes
)

# Create /usr/share/pki/server/lib. This can be customized for different platforms in RPM spec.

add_custom_target(pki-server-lib ALL)

add_custom_command(
    TARGET pki-server-lib
    COMMAND ${CMAKE_COMMAND} -E make_directory lib
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_API_JAR} lib/slf4j-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_JDK14_JAR} lib/slf4j-jdk14.jar
)

# Create /usr/share/pki/server/common/lib. This can be customized for different platforms in RPM spec.

add_custom_target(pki-server-common-lib ALL)

add_custom_command(
    TARGET pki-server-common-lib
    COMMAND ${CMAKE_COMMAND} -E make_directory common/lib
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_CODEC_JAR} common/lib/commons-codec.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_COLLECTIONS_JAR} common/lib/commons-collections.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_IO_JAR} common/lib/commons-io.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_LANG_JAR} common/lib/commons-lang.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${COMMONS_LOGGING_JAR} common/lib/commons-logging.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${HTTPCLIENT_JAR} common/lib/httpclient.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${HTTPCORE_JAR} common/lib/httpcore.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON_CORE_JAR} common/lib/jackson-core-asl.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON_JAXRS_JAR} common/lib/jackson-jaxrs.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON_MAPPER_JAR} common/lib/jackson-mapper-asl.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON_MRBEAN_JAR} common/lib/jackson-mrbean.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON_SMILE_JAR} common/lib/jackson-smile.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JACKSON_XC_JAR} common/lib/jackson-xc.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink /usr/share/java/javassist.jar common/lib/javassist.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JSS_JAR} common/lib/jss4.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${LDAPJDK_JAR} common/lib/ldapjdk.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${NUXWDOG_JAR} common/lib/nuxwdog.jar
    COMMAND ln -sf /usr/share/java/pki/pki-nsutil.jar ${CMAKE_CURRENT_BINARY_DIR}/common/lib/pki-nsutil.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmsutil.jar ${CMAKE_CURRENT_BINARY_DIR}/common/lib/pki-cmsutil.jar
    COMMAND ln -sf /usr/share/java/pki/pki-tomcat.jar ${CMAKE_CURRENT_BINARY_DIR}/common/lib/pki-tomcat.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${RESTEASY_LIB}/resteasy-atom-provider.jar common/lib/resteasy-atom-provider.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${RESTEASY_LIB}/resteasy-client.jar common/lib/resteasy-client.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${RESTEASY_LIB}/resteasy-jackson-provider.jar common/lib/resteasy-jackson-provider.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${RESTEASY_LIB}/resteasy-jaxb-provider.jar common/lib/resteasy-jaxb-provider.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${JAXRS_API_JAR} common/lib/jaxrs-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${RESTEASY_LIB}/resteasy-jaxrs.jar common/lib/resteasy-jaxrs.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink /usr/share/java/scannotation.jar common/lib/scannotation.jar
    COMMAND ln -sf /usr/lib/java/symkey.jar ${CMAKE_CURRENT_BINARY_DIR}/common/lib/symkey.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${TOMCATJSS_JAR} common/lib/tomcatjss.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${VELOCITY_JAR} common/lib/velocity.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${XERCES_JAR} common/lib/xerces-j2.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${XML_COMMONS_APIS_JAR} common/lib/xml-commons-apis.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${XML_COMMONS_RESOLVER_JAR} common/lib/xml-commons-resolver.jar
)

# Create /usr/share/pki/server/webapps/pki/WEB-INF/lib. This can be customized for different platforms in RPM spec.

add_custom_target(pki-server-webapp-lib ALL)

add_custom_command(
    TARGET pki-server-webapp-lib
    COMMAND ${CMAKE_COMMAND} -E make_directory webapp/lib
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_API_JAR} webapp/lib/slf4j-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_JDK14_JAR} webapp/lib/slf4j-jdk14.jar
    COMMAND ln -sf /usr/share/java/pki/pki-certsrv.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-certsrv.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cms.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cms.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmscore.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cmscore.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmsbundle.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cmsbundle.jar
)

install(
    FILES
         ${CMAKE_CURRENT_BINARY_DIR}/share/etc/tomcat.conf
    DESTINATION
        ${DATA_INSTALL_DIR}/etc/
)

install(
    DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/lib/
    DESTINATION
        ${DATA_INSTALL_DIR}/server/lib
)

install(
    DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/common/lib/
    DESTINATION
        ${DATA_INSTALL_DIR}/server/common/lib
)

install(
    DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/
    DESTINATION
        ${DATA_INSTALL_DIR}/server/webapps/pki/WEB-INF/lib
)

install(
    DIRECTORY
        man/
    DESTINATION
        ${MAN_INSTALL_DIR}
    FILE_PERMISSIONS
        OWNER_READ OWNER_WRITE
        GROUP_READ
        WORLD_READ
)

# install Python libraries
if(WITH_PYTHON3_DEFAULT)
    install(
        DIRECTORY
            python/pki/server
        DESTINATION
            ${PYTHON3_SITE_PACKAGES}/pki
        FILES_MATCHING PATTERN
            *.py
    )
else()
    install(
        DIRECTORY
            python/pki/server
        DESTINATION
            ${PYTHON2_SITE_PACKAGES}/pki
        FILES_MATCHING PATTERN
            *.py
    )
endif()

# install systemd scripts
install(
    DIRECTORY
        share/lib/systemd/system/
    DESTINATION
        ${SYSTEMD_LIB_INSTALL_DIR}
    FILE_PERMISSIONS
        OWNER_EXECUTE OWNER_WRITE OWNER_READ
        GROUP_EXECUTE GROUP_READ
        WORLD_EXECUTE WORLD_READ
)

install(
    FILES
        setup/CertServer.directory
        setup/menu.xml
        setup/pkidaemon_registry
    DESTINATION
        ${DATA_INSTALL_DIR}/setup/
    PERMISSIONS
        OWNER_WRITE OWNER_READ
        GROUP_READ
        WORLD_READ
)

# install executables
install(
    FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/sbin/pki-server-nuxwdog
        ${CMAKE_CURRENT_BINARY_DIR}/sbin/pki-server
        ${CMAKE_CURRENT_BINARY_DIR}/sbin/pki-server-upgrade
        ${CMAKE_CURRENT_BINARY_DIR}/sbin/pkidestroy
        ${CMAKE_CURRENT_BINARY_DIR}/sbin/pkispawn
    DESTINATION
        ${SBIN_INSTALL_DIR}
    PERMISSIONS
        OWNER_EXECUTE OWNER_WRITE OWNER_READ
        GROUP_EXECUTE GROUP_READ
        WORLD_EXECUTE WORLD_READ
)

install(
    DIRECTORY
        upgrade
    DESTINATION
        ${DATA_INSTALL_DIR}/server/
    FILE_PERMISSIONS
        OWNER_EXECUTE OWNER_WRITE OWNER_READ
        GROUP_EXECUTE GROUP_READ
        WORLD_EXECUTE WORLD_READ
    PATTERN ".gitignore" EXCLUDE
)

install(
    FILES
        scripts/pkidaemon
    DESTINATION
        ${BIN_INSTALL_DIR}
    PERMISSIONS
        OWNER_EXECUTE OWNER_WRITE OWNER_READ
        GROUP_EXECUTE GROUP_READ
        WORLD_EXECUTE WORLD_READ
)

install(
    FILES
        scripts/operations
    DESTINATION
        ${DATA_INSTALL_DIR}/scripts/
    PERMISSIONS
        OWNER_EXECUTE OWNER_WRITE OWNER_READ
        GROUP_EXECUTE GROUP_READ
        WORLD_EXECUTE WORLD_READ
)

install(
    DIRECTORY
        config
    DESTINATION
        ${DATA_INSTALL_DIR}/deployment
)

# install server files
install(
    DIRECTORY
        share/
    DESTINATION
        ${DATA_INSTALL_DIR}/server/
    PATTERN
        "lib/*" EXCLUDE
    PATTERN
        "etc/*" EXCLUDE
)

# install server configuration files
install(
    DIRECTORY
        etc/
    DESTINATION
        ${SYSCONF_INSTALL_DIR}/pki
)

# install empty directories
install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${VAR_INSTALL_DIR}/lock/pki)")
install(CODE "file(MAKE_DIRECTORY \$ENV{DESTDIR}${VAR_INSTALL_DIR}/run/pki)")

=== base/tks/CMakeLists.txt ===
project(tks NONE)

add_subdirectory(src)
add_subdirectory(setup)
add_subdirectory(shared/conf)
add_subdirectory(${APP_SERVER})

# Create links at /usr/share/pki/tks/webapps/tks/admin/console.
# Create /usr/share/pki/tks/webapps/tks/WEB-INF/lib.
# This can be customized for different platforms in RPM spec.

add_custom_target(pki-tks-links ALL)

add_custom_command(
    TARGET pki-tks-links
    COMMAND ${CMAKE_COMMAND} -E make_directory webapp/admin
    COMMAND ln -sf ${DATA_INSTALL_DIR}/server/webapps/pki/admin/console ${CMAKE_CURRENT_BINARY_DIR}/webapp/admin
    COMMAND ${CMAKE_COMMAND} -E make_directory webapp/lib
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_API_JAR} webapp/lib/slf4j-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_JDK14_JAR} webapp/lib/slf4j-jdk14.jar
    COMMAND ln -sf /usr/share/java/pki/pki-certsrv.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-certsrv.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cms.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cms.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmscore.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cmscore.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmsbundle.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cmsbundle.jar
    COMMAND ln -sf /usr/share/java/pki/pki-tks.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-tks.jar
)

# install directories
install(
    DIRECTORY
        shared/
    DESTINATION
        ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}
    PATTERN
        "CMakeLists.txt" EXCLUDE
)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/webapp/admin/
    DESTINATION
        ${DATA_INSTALL_DIR}/tks/webapps/tks/admin
)

install(
    DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/
    DESTINATION
        ${DATA_INSTALL_DIR}/tks/webapps/tks/WEB-INF/lib
)

# install empty directories
install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/lock/pki/tks
)

install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/run/pki/tks
)

=== base/tps/CMakeLists.txt ===
project(tps Java)

add_subdirectory(src)

# install files
add_subdirectory(setup)
add_subdirectory(shared/conf)
add_subdirectory(${APP_SERVER})

# TPS does not support admin console.
# Create links in /usr/share/pki/tps/webapps/tps/WEB-INF/lib.
# This can be customized for different platforms in RPM spec.

add_custom_target(pki-tps-links ALL)

add_custom_command(
    TARGET pki-tps-links
    COMMAND ${CMAKE_COMMAND} -E make_directory webapp/lib
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_API_JAR} webapp/lib/slf4j-api.jar
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SLF4J_JDK14_JAR} webapp/lib/slf4j-jdk14.jar
    COMMAND ln -sf /usr/share/java/pki/pki-certsrv.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-certsrv.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cms.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cms.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmscore.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cmscore.jar
    COMMAND ln -sf /usr/share/java/pki/pki-cmsbundle.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-cmsbundle.jar
    COMMAND ln -sf /usr/share/java/pki/pki-tps.jar ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/pki-tps.jar
)

# install manual pages
install(
    DIRECTORY
        man/
    DESTINATION
        ${MAN_INSTALL_DIR}
    FILE_PERMISSIONS
        OWNER_READ OWNER_WRITE
        GROUP_READ
        WORLD_READ
)

# install directories
install(
    DIRECTORY
        shared/
    DESTINATION
        ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}
    PATTERN
        "CMakeLists.txt" EXCLUDE
)

install(
    DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/webapp/lib/
    DESTINATION
        ${DATA_INSTALL_DIR}/tps/webapps/tps/WEB-INF/lib
)

# install empty directories
install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/lock/pki/tps
)

install(
    DIRECTORY
    DESTINATION
        ${VAR_INSTALL_DIR}/run/pki/tps
)

=== debian/changelog ===
dogtag-pki (10.6.0-1ubuntu2) bionic; urgency=medium

  * control: Add conflicts on libtomcat7-java to pki-server.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 25 Apr 2018 10:00:08 +0300

dogtag-pki (10.6.0-1ubuntu1) bionic; urgency=medium

  * rules: Build everything in one pass.
  * Fix ACL evaluation in allow,deny mode. (Closes: #893690)
    - CVE-2018-1080

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 18 Apr 2018 15:07:20 +0300

dogtag-pki (10.6.0-1) experimental; urgency=medium

  * New upstream release.
  * control: Update VCS urls.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 18 Apr 2018 00:22:25 +0300

dogtag-pki (10.6.0~beta2-3) experimental; urgency=medium

  * rules: Fix JAVA_HOME, create a symlink to the native jvm dir and
    ship it with pki-server.
  * pki-base.postinst: Modify JAVA_HOME for installed instances on
    upgrade.
  * debian-support.diff: Revert start delay to 5s, use systemctl
    enable/disable.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 10 Apr 2018 13:20:34 +0300

dogtag-pki (10.6.0~beta2-2) experimental; urgency=medium

  * pki-tools: Add new manpages.
  * debian-support.diff: Fix keystore permissions.
  * debian-support.diff: Skip systemctl enable/disable.
  * control: Add openjdk-8-jre-headless to pki-base-java depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 06 Apr 2018 16:11:04 +0300

dogtag-pki (10.6.0~beta2-1) experimental; urgency=medium

  * New upstream prerelease.
  * patches: Refreshed.
  * control, rules: Build using tomcat 8.5, adjust dependencies to
    match.
  * fix-jar-search.diff: Dropped, upstream
  * rules: Use sql nssdb's by default.
  * debian-support.diff: Bump the delay after starting the instance to 10s.
  * fix-symkey-path.diff: Move symkey.jar handling here from fix-jar-
    search.diff.
  * fix-tomcat-paths.diff: Use tomcat paths provided by Debian,
    merge fix-cli-migrate.diff here.
  * tools: DRMTool links are handled by cmake now, drop .links.
  * rules: Don't clean usr/share/pki/server/lib before dh_install, it's
    jar symlinks now.
  * base.install: Updated.
  * control, rules: Build using JDK8.
  * control: Add python3-distutils to build-depends.
  * rename-logging-config.diff: Dropped, upstream.
  * use-bindsto.diff: Dropped, upstream.
  * fix-cve-2016-1240.diff: Dropped, upstream.
  * debian-support.diff: Tomcat setup upstreamed.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 30 Mar 2018 09:18:41 +0300

dogtag-pki (10.5.5-1) unstable; urgency=medium

  * New upstream release.
  * tests: Add some debugging info, and force the hostname if it isn't
    set.
  * patches: Refreshed.
  * tools.install: Updated.
  * tests: Remove installed instances.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 09 Feb 2018 16:29:06 +0200

dogtag-pki (10.5.3-4) unstable; urgency=medium

  * rules: Remove resteasy-jandex-jaxrs.jar symlink, it looks unused
    anyway. (Closes: #857150)
  * tests: Sleep for 10 seconds between spawning instances, it seems
    racy otherwise.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 05 Jan 2018 10:36:19 +0200

dogtag-pki (10.5.3-3) unstable; urgency=medium

  * control: Add libhttpclient-java, libhttpcore-java, libjaxrs-api-java to
    pki-base-java Depends.
  * rename-logging-config.diff: Rename LOGGING_CONFIG to
    PKI_LOGGING_CONFIG, otherwise catalina startup would fail.
  * fix-jar-search.diff: Fix search for commons-collections3.jar and
    symkey.jar.
  * rules: Link jboss-logging.jar under server/common/lib too.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 22 Dec 2017 14:32:32 +0200

dogtag-pki (10.5.3-2) unstable; urgency=medium

  * control: Add python{,3}-cryptography to pki-base, pki-server and
    python3-pki-base Depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 22 Dec 2017 00:52:21 +0200

dogtag-pki (10.5.3-1) unstable; urgency=medium

  * New upstream release.
  * watch: Updated, upstream provides proper tags now.
  * copyright: Add Files-Excluded for tarball rebuild.
  * patches: Drop fix-CVE-2017-7537.diff, refresh others.
  * use-usr-bin.diff: Replace with an upstreamed patch.
  * Drop fix-junit-jar.diff, add fix-jar-search.diff and modify debian-
    support.diff and rules to not hardcode distro-specific jar names.
  * control: Add libslf4j-java, libhttpclient-java, libhttpcore-java to
    build-depends/depends.
  * control: Bump dependency on libjss-java.
  * rules: Use dh_missing, and drop creating links under subsys dirs as
    that is handled by CMake now.
  * *install: Added new files to -base, -server and -tools.
  * control: Bump dependency on libldap-java.
  * use-bindsto.diff: Fix pki-tpsd.service to use BindsTo instead of
    BindTo. (Closes: #857186)

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 21 Dec 2017 18:11:15 +0200

dogtag-pki (10.3.5+12-6) unstable; urgency=medium

  * Fix autopkgtest to be robust in the face of changed iproute2 output.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 21 Dec 2017 10:59:59 +0200

dogtag-pki (10.3.5+12-5) unstable; urgency=medium

  * rules: Add a link to jboss-logging.jar.
  * pki-base, pki-server: Fix postinst, strip cruft from the version string.
  * control: Use tomcat8.0. (Closes: #823332, #846714)
  * control: Add libcommons-httpclient-java to build-depends, and
    pki-base-java depends.
  * control: Use resteasy3.0.
  * fix-CVE-2017-7537.diff: Change defaults for cmc plugin. (Closes:
    #869261)
  * control: Bump dependency on libtomcajss-java to verify we have the
    correct build.

 -- Timo Aaltonen <tjaalton@debian.org>  Sat, 21 Oct 2017 11:58:04 +0300

=== debian/control ===
Source: dogtag-pki
Section: java
Priority: optional
Maintainer: Debian FreeIPA Team <pkg-freeipa-devel@lists.alioth.debian.org>
Uploaders: Timo Aaltonen <tjaalton@debian.org>
Build-Depends:
 apache2-dev,
 cmake,
 debhelper (>= 9),
 openjdk-8-jdk,
 dh-python,
 dh-systemd,
 javahelper,
 junit4,
 libcommons-cli-java,
 libcommons-codec-java,
 libcommons-httpclient-java,
 libcommons-io-java,
 libcommons-lang-java,
 libhttpclient-java,
 libhttpcore-java,
 libidm-console-framework-java,
 libjackson2-annotations-java,
 libjaxrs-api-java,
 libjss-java (>= 4.4.2-2),
 libldap-java (>= 4.19+dfsg1-1),
 libldap2-dev,
 libnspr4-dev,
 libnss3-dev,
 libnuxwdog-java,
 libresteasy3.0-java,
 libservlet3.1-java,
 libslf4j-java,
 libsvrcore-dev,
 libtomcat8-java,
 libtomcatjss-java (>= 7.3.0~),
 libxalan2-java,
 libxerces2-java,
 pkg-config,
 policycoreutils,
 python-cryptography,
 python-dev,
 python-nss,
 python-requests,
 python-sphinx,
 python-urllib3,
 python3-dev,
 python3-distutils,
 velocity,
 zlib1g-dev,
Standards-Version: 3.9.5
Homepage: http://pki.fedoraproject.org
Vcs-Git: https://salsa.debian.org/freeipa-team/dogtag-pki.git
Vcs-Browser: https://salsa.debian.org/freeipa-team/dogtag-pki

Package: dogtag-pki
Architecture: all
Depends:
 dogtag-pki-console-theme,
 dogtag-pki-server-theme,
 pki-base,
 pki-ca,
 pki-console,
 pki-javadoc,
 pki-kra,
 pki-ocsp,
 pki-server,
 pki-tks,
 pki-tools,
 pki-tps,
 ${misc:Depends},
Description: Dogtag Public Key Infrastructure (PKI) Suite
 The Dogtag Public Key Infrastructure (PKI) Suite is comprised of the following
 five subsystems and a client (for use by a Token Management System):
 .
   * Certificate Authority (CA)
   * Data Recovery Manager (DRM)
   * Online Certificate Status Protocol (OCSP) Manager
   * Token Key Service (TKS)
   * Token Processing System (TPS)
   * Enterprise Security Client (ESC)
 .
 Additionally, it provides a console GUI application used for server and
 user/group administration of CA, DRM, OCSP, and TKS, javadocs on portions
 of the Dogtag API, as well as various command-line tools used to assist with
 a PKI deployment.

Package: pki-base
Architecture: all
Depends:
 python-cryptography,
 python-nss,
 python-requests,
 python-urllib3,
 ${misc:Depends},
 ${python:Depends},
Description: Certificate System - PKI Framework
 The PKI Framework contains the common and client libraries and utilities.
 .
 This package is a part of the PKI Core used by the Certificate System.

Package: pki-base-java
Architecture: all
Replaces: pki-base (<< 10.3.5-1)
Breaks: pki-base (<< 10.3.5-1)
Depends:
 libcommons-cli-java,
 libcommons-codec-java,
 libcommons-httpclient-java,
 libcommons-io-java,
 libcommons-lang-java,
 libcommons-logging-java,
 libhttpclient-java,
 libhttpcore-java,
 libjaxrs-api-java,
 libjavassist-java,
 libjettison-java,
 libjss-java (>= 4.4.2-2),
 libldap-java (>= 4.19+dfsg1-1),
 libresteasy3.0-java,
 libservlet3.1-java,
 libslf4j-java,
 libxalan2-java,
 libxerces2-java,
 libxml-commons-external-java,
 libxml-commons-resolver1.1-java,
 openjdk-8-jre-headless,
 pki-base (= ${binary:Version}),
 ${java:Depends},
 ${misc:Depends},
Description: Certificate System - PKI Framework -- java client support
 The PKI Framework contains the common and client libraries and utilities.
 .
 This package is a part of the PKI Core used by the Certificate System.

Package: python3-pki-base
Architecture: all
Depends:
 pki-base (= ${binary:Version}),
 python3-cryptography,
 python3-nss,
 python3-requests,
 python3-urllib3,
 ${misc:Depends},
 ${python3:Depends},
Description:  Certificate System - PKI Framework -- python3 client support
 The PKI Framework contains the common and client libraries and utilities.
 .
 This package is a part of the PKI Core used by the Certificate System.

Package: pki-tools
Architecture: any
Depends:
 ldap-utils,
 libjackson2-annotations-java,
 libnss3-tools,
 pki-base (= ${source:Version}),
 ${java:Depends},
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends},
Conflicts: strongswan-starter, strongswan-pki
Description: Certificate System - PKI Tools
 This package contains PKI executables that can be used to help make
 Certificate System into a more complete and robust PKI solution.
 .
 This package is a part of the PKI Core used by the Certificate System.

Package: pki-server
Architecture: any
Depends:
 adduser,
 dogtag-pki-server-theme (>= ${source:Version}),
 ldap-utils,
 libatk-wrapper-java,
 libcommons-collections3-java,
 libcommons-dbcp-java,
 libcommons-pool-java,
 libjackson-json-java,
 libjackson2-annotations-java,
 libjackson2-jaxrs-providers-java,
 libjboss-logging-java,
 libjs-jquery,
 libjs-underscore,
 libscannotation-java,
 libsymkey-java (= ${source:Version}),
 libtomcatjss-java (>= 7.3.0~),
 libnuxwdog-java,
 libxml-commons-external-java,
 libxml-commons-resolver1.1-java,
 pki-base (= ${source:Version}),
 pki-base-java (= ${source:Version}),
 pki-tools (= ${binary:Version}),
 python-cryptography,
 python-ldap,
 python-lxml,
 python-selinux,
 tomcat8-user,
 velocity,
 ${java:Depends},
 ${misc:Depends},
 ${python:Depends},
Conflicts: libtomcat7-java
Description: Certificate System - PKI Server Framework
 The PKI Server Framework is required by the following four PKI subsystems:
 .
     the Certificate Authority (CA),
     the Data Recovery Manager (DRM),
     the Online Certificate Status Protocol (OCSP) Manager, and
     the Token Key Service (TKS).
 .
 This package is a part of the PKI Core used by the Certificate System.
 The package contains scripts to create and remove PKI subsystems.

Package: pki-ca
Architecture: all
Depends: pki-server (>= ${source:Version}), ${java:Depends}, ${misc:Depends}
Suggests: 389-ds-base
Description: Certificate System - Certificate Authority
 The Certificate Authority (CA) is a required PKI subsystem which issues,
 renews, revokes, and publishes certificates as well as compiling and
 publishing Certificate Revocation Lists (CRLs).
 .
 The Certificate Authority can be configured as a self-signing Certificate
 Authority, where it is the root CA, or it can act as a subordinate CA,
 where it obtains its own signing certificate from a public CA.
 .
 This package is a part of the PKI Core used by the Certificate System.

Package: dogtag-pki-console-theme
Architecture: all
Section: web
Depends: ${java:Depends}, ${misc:Depends}
Description: Certificate System - PKI Console User Interface
 This PKI Console User Interface contains the Dogtag textual
 and graphical user interface for the PKI Console.
 .
 This package is used by the Dogtag Certificate System.

Package: dogtag-pki-server-theme
Architecture: all
Section: web
Depends: ${java:Depends}, ${misc:Depends}
Description: Certificate System - PKI Server User Interface
 This PKI Common Framework User Interface contains the Dogtag
 textual and graphical user interface for the PKI Common Framework.
 .
 This package is used by the Dogtag Certificate System.

Package: pki-console
Architecture: all
Depends:
 dogtag-pki-console-theme,
 libidm-console-framework-java,
 libjss-java,
 libldap-java,
 pki-base (>= 10.0),
 ${java:Depends},
 ${misc:Depends},
Description: Certificate System - PKI Console
 Certificate System (CS) is an enterprise software system designed
 to manage enterprise Public Key Infrastructure (PKI) deployments.
 .
 The PKI Console is a java application used to administer CS.

Package: pki-kra
Architecture: all
Depends: pki-server (>= ${source:Version}), ${java:Depends}, ${misc:Depends}
Suggests: pki-ca
Description: Certificate System - Data Recovery Manager
 Certificate System (CS) is an enterprise software system designed
 to manage enterprise Public Key Infrastructure (PKI) deployments.
 .
 The Data Recovery Manager (DRM) is an optional PKI subsystem that can act
 as a Key Recovery Authority (KRA).  When configured in conjunction with the
 Certificate Authority (CA), the DRM stores private encryption keys as part of
 the certificate enrollment process.  The key archival mechanism is triggered
 when a user enrolls in the PKI and creates the certificate request.  Using the
 Certificate Request Message Format (CRMF) request format, a request is
 generated for the user's private encryption key.  This key is then stored in
 the DRM which is configured to store keys in an encrypted format that can only
 be decrypted by several agents requesting the key at one time, providing for
 protection of the public encryption keys for the users in the PKI deployment.
 .
 Note that the DRM archives encryption keys; it does NOT archive signing keys,
 since such archival would undermine non-repudiation properties of signing keys.

Package: pki-ocsp
Architecture: all
Depends: pki-server (>= ${source:Version}), ${java:Depends}, ${misc:Depends}
Suggests: pki-ca
Description: Certificate System - Online Certificate Status Protocol Manager
 Certificate System (CS) is an enterprise software system designed
 to manage enterprise Public Key Infrastructure (PKI) deployments.
 .
 The Online Certificate Status Protocol (OCSP) Manager is an optional PKI
 subsystem that can act as a stand-alone OCSP service.  The OCSP Manager
 performs the task of an online certificate validation authority by enabling
 OCSP-compliant clients to do real-time verification of certificates.  Note
 that an online certificate-validation authority is often referred to as an
 OCSP Responder.
 .
 Although the Certificate Authority (CA) is already configured with an
 internal OCSP service.  An external OCSP Responder is offered as a separate
 subsystem in case the user wants the OCSP service provided outside of a
 firewall while the CA resides inside of a firewall, or to take the load of
 requests off of the CA.
 .
 The OCSP Manager can receive Certificate Revocation Lists (CRLs) from
 multiple CA servers, and clients can query the OCSP Manager for the
 revocation status of certificates issued by all of these CA servers.
 .
 When an instance of OCSP Manager is set up with an instance of CA, and
 publishing is set up to this OCSP Manager, CRLs are published to it
 whenever they are issued or updated.

Package: pki-tks
Architecture: all
Depends:
 libsymkey-java (>= ${source:Version}),
 pki-server (>= ${source:Version}),
 ${java:Depends},
 ${misc:Depends},
Suggests: pki-ca
Description: Certificate System - Token Key Service
 Certificate System (CS) is an enterprise software system designed
 to manage enterprise Public Key Infrastructure (PKI) deployments.
 .
 The Token Key Service (TKS) is an optional PKI subsystem that manages the
 master key(s) and the transport key(s) required to generate and distribute
 keys for hardware tokens.  TKS provides the security between tokens and an
 instance of Token Processing System (TPS), where the security relies upon the
 relationship between the master key and the token keys.  A TPS communicates
 with a TKS over SSL using client authentication.
 .
 TKS helps establish a secure channel (signed and encrypted) between the token
 and the TPS, provides proof of presence of the security token during
 enrollment, and supports key changeover when the master key changes on the
 TKS.  Tokens with older keys will get new token keys.
 .
 Because of the sensitivity of the data that TKS manages, TKS should be set up
 behind the firewall with restricted access.

Package: pki-tps
Architecture: all
Depends:
 pki-server (>= ${source:Version}),
 ${java:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Suggests: pki-ca, pki-kra, pki-tks
Description: Certificate System - Token Processing System
 Certificate System (CS) is an enterprise software system designed
 to manage enterprise Public Key Infrastructure (PKI) deployments.
 .
 The Token Processing System (TPS) is an optional PKI subsystem that acts
 as a Registration Authority (RA) for authenticating and processing
 enrollment requests, PIN reset requests, and formatting requests from
 the Enterprise Security Client (ESC).
 .
 TPS is designed to communicate with tokens that conform to

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

VER :=  $(shell dpkg-parsechangelog | sed -n 's/^Version: *\(.*\)-.*$$/\1/ p' | sed -e 's/~.*//')

DEB_BUILD_ARCH = $(shell dpkg-architecture -q DEB_BUILD_ARCH)
JAVA_HOME=/usr/lib/jvm/java-8-openjdk-$(DEB_BUILD_ARCH)
PKI_JAVA_HOME=debian/tmp/usr/share/pki/java-home
CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS += -I/usr/include/nss $(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
export CXXFLAGS += -I/usr/include/nss -I/usr/include/apr-1.0 $(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
export LDFLAGS += $(shell dpkg-buildflags --get LDFLAGS)
DEB_BUILD_DIR ?= $(CURDIR)/build

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKE_FLAGS += -j$(NUMJOBS)
endif

CONFIGS = core

STAMP_DIR = debian/stamp
STAMP = $(STAMP_DIR)/$(DEB_BUILD_GNU_TYPE)
BUILD_STAMPS = $(addprefix $(STAMP)-build-, $(CONFIGS))

confflags = 

confflags-core = \
	-DJAVA_HOME=$(JAVA_HOME) \
	-DVERSION=$(VER) \
	-DSYSTEMD_LIB_INSTALL_DIR=/lib/systemd/system \
	-DVAR_INSTALL_DIR:PATH=/var \
	-DRESTEASY_LIB=/usr/share/java/ \
	-DPKI_CERTSRV_JAR=$(DEB_BUILD_DIR)/core/dist/pki-certsrv.jar \
	-DPKI_CMS_JAR=$(DEB_BUILD_DIR)/core/dist/pki-cms.jar \
	-DPKI_CMSBUNDLE_JAR=$(DEB_BUILD_DIR)/core/dist/pki-cmsbundle.jar \
	-DPKI_CMSCORE_JAR=$(DEB_BUILD_DIR)/core/dist/pki-cmscore.jar \
	-DPKI_CMSUTIL_JAR=$(DEB_BUILD_DIR)/core/dist/pki-cmsutil.jar \
	-DPKI_NSS_DB_TYPE=sql \
	-DPKI_NSUTIL_JAR=$(DEB_BUILD_DIR)/core/dist/pki-nsutil.jar \
	-DBUILD_PKI_CORE:BOOL=ON \
	-DAPP_SERVER=tomcat-8.5 \
	-DBUILD_PKI_CONSOLE:BOOL=ON \
	-DBUILD_DOGTAG_PKI_THEME:BOOL=ON \

%:
	dh $@ --parallel --with javahelper,python2,python3,systemd,apache2 --builddirectory=build/

override_dh_auto_clean:
	rm -rf $(CURDIR)/build
	rm -f $(CURDIR)/base/common/python/pki/*.pyc

override_dh_auto_configure:

build-stamp: $(BUILD_STAMPS)
	>$@

$(STAMP)-build-%:
	mkdir -p $(DEB_BUILD_DIR)/$*
	cd $(DEB_BUILD_DIR)/$* && \
	cmake -DCMAKE_INSTALL_PREFIX=/usr \
		-DSYSCONF_INSTALL_DIR:PATH=/etc \
		-DVAR_INSTALL_DIR:PATH=/var \
		-DJAVA_LIB_INSTALL_DIR=/usr/share/java \
		$(confflags-$*) \
		../../
	cd $(DEB_BUILD_DIR)/$* && make VERBOSE=1 $(MAKE_FLAGS)

override_dh_auto_build: build-stamp

override_dh_auto_install:
	set -e; for config in $(CONFIGS); do \
		make -C $(DEB_BUILD_DIR)/$$config DESTDIR=$(CURDIR)/debian/tmp install; \
	done

	find $(CURDIR)/debian/tmp/usr/share/pki -name '*.cgi' -exec chmod 755 '{}' ';'
	find $(CURDIR)/debian/tmp/usr/share/pki -name '*.pl' -exec chmod 755 '{}' ';'
	find $(CURDIR)/debian/tmp/lib/systemd -exec chmod 644 '{}' ';'

override_dh_installinit:
	dh_installinit -ppki-server --name=pki-tomcatd --error-handler=invoke_failure

override_dh_systemd_enable:
	dh_systemd_enable -ppki-server --no-enable pki-tomcatd@.service
	dh_systemd_enable -ppki-server --no-enable pki-tomcatd-nuxwdog@.service

override_dh_install:
	# we don't use these
	rm -rf $(CURDIR)/debian/tmp/etc/rc.d

	# tpsclient hasn't been ported to java yet
	rm -rf $(CURDIR)/debian/tmp/lib/systemd/system/pki-tpsd* \
		$(CURDIR)/debian/tmp/usr/lib/httpd/modules/mod_tps.so \
		$(CURDIR)/debian/tmp/usr/lib/httpd/modules/mod_tokendb.so \
		$(CURDIR)/debian/tmp/usr/lib/tps/libldapauth.so \
		$(CURDIR)/debian/tmp/usr/share/pki/tps/cgi-bin \
		$(CURDIR)/debian/tmp/usr/share/pki/tps/docroot \
		$(CURDIR)/debian/tmp/usr/share/pki/tps/lib \
		$(CURDIR)/debian/tmp/usr/share/pki/tps/scripts \
		$(CURDIR)/debian/tmp/usr/share/pki/tps/samples

	# not needed since we don't ship any binary applets
	rm -rf $(CURDIR)/debian/tmp/usr/share/pki/tps/applets

	ln -sf /usr/share/java/jboss-logging.jar $(CURDIR)/debian/tmp/usr/share/pki/lib/jboss-logging.jar
	ln -sf /usr/share/java/jboss-logging.jar $(CURDIR)/debian/tmp/usr/share/pki/server/common/lib/jboss-logging.jar

	# use our own symlink to the arch-dependent java dir
	ln -sf $(JAVA_HOME) $(PKI_JAVA_HOME)
	sed -i 's/lib\/jvm\/java-8-openjdk.*/share\/pki\/java-home/' \
		debian/tmp/usr/share/pki/etc/pki.conf

	rm -f $(CURDIR)/debian/tmp/usr/share/pki/lib/resteasy-jaxrs-jandex.jar

	dh_install

override_dh_missing:
	dh_missing --fail-missing

get-orig-source: SOURCE=dogtag-pki
get-orig-source: UV=$(shell dpkg-parsechangelog|awk '/^Version:/ {print $$2}'|sed 's/-.*$$//')
get-orig-source:
	tar --transform 's,^,$(SOURCE)-$(UV)/,' \
		--exclude 'debian' --exclude-vcs \
		-cJf ../$(SOURCE)_$(UV).orig.tar.xz .

=== debian/tests/control ===
Tests: pkispawn
Depends:
 @,
 389-ds-base,
 procps,
Restrictions:
 allow-stderr,
 needs-root,

=== debian/watch ===
version=4
opts="compression=xz,repack,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%dogtag-pki-$1.tar.xz%" \
https://github.com/dogtagpki/pki/tags/ (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
